/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the OrganizationUsersList type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &OrganizationUsersList{}

// OrganizationUsersList struct for OrganizationUsersList
type OrganizationUsersList struct {
	Results []OrganizationUser `json:"results,omitempty"`
	Total *int32 `json:"total,omitempty"`
}

// NewOrganizationUsersList instantiates a new OrganizationUsersList object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewOrganizationUsersList() *OrganizationUsersList {
	this := OrganizationUsersList{}
	return &this
}

// NewOrganizationUsersListWithDefaults instantiates a new OrganizationUsersList object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewOrganizationUsersListWithDefaults() *OrganizationUsersList {
	this := OrganizationUsersList{}
	return &this
}

// GetResults returns the Results field value if set, zero value otherwise.
func (o *OrganizationUsersList) GetResults() []OrganizationUser {
	if o == nil || IsNil(o.Results) {
		var ret []OrganizationUser
		return ret
	}
	return o.Results
}

// GetResultsOk returns a tuple with the Results field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OrganizationUsersList) GetResultsOk() ([]OrganizationUser, bool) {
	if o == nil || IsNil(o.Results) {
		return nil, false
	}
	return o.Results, true
}

// HasResults returns a boolean if a field has been set.
func (o *OrganizationUsersList) HasResults() bool {
	if o != nil && !IsNil(o.Results) {
		return true
	}

	return false
}

// SetResults gets a reference to the given []OrganizationUser and assigns it to the Results field.
func (o *OrganizationUsersList) SetResults(v []OrganizationUser) {
	o.Results = v
}

// GetTotal returns the Total field value if set, zero value otherwise.
func (o *OrganizationUsersList) GetTotal() int32 {
	if o == nil || IsNil(o.Total) {
		var ret int32
		return ret
	}
	return *o.Total
}

// GetTotalOk returns a tuple with the Total field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OrganizationUsersList) GetTotalOk() (*int32, bool) {
	if o == nil || IsNil(o.Total) {
		return nil, false
	}
	return o.Total, true
}

// HasTotal returns a boolean if a field has been set.
func (o *OrganizationUsersList) HasTotal() bool {
	if o != nil && !IsNil(o.Total) {
		return true
	}

	return false
}

// SetTotal gets a reference to the given int32 and assigns it to the Total field.
func (o *OrganizationUsersList) SetTotal(v int32) {
	o.Total = &v
}

func (o OrganizationUsersList) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o OrganizationUsersList) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Results) {
		toSerialize["results"] = o.Results
	}
	if !IsNil(o.Total) {
		toSerialize["total"] = o.Total
	}
	return toSerialize, nil
}

type NullableOrganizationUsersList struct {
	value *OrganizationUsersList
	isSet bool
}

func (v NullableOrganizationUsersList) Get() *OrganizationUsersList {
	return v.value
}

func (v *NullableOrganizationUsersList) Set(val *OrganizationUsersList) {
	v.value = val
	v.isSet = true
}

func (v NullableOrganizationUsersList) IsSet() bool {
	return v.isSet
}

func (v *NullableOrganizationUsersList) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableOrganizationUsersList(val *OrganizationUsersList) *NullableOrganizationUsersList {
	return &NullableOrganizationUsersList{value: val, isSet: true}
}

func (v NullableOrganizationUsersList) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableOrganizationUsersList) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


